Loading...
Searching...
No Matches
etl::factory< MAX_SIZE_, T1, T2, T3, T4, T5, T6, T7, T8, T9, T10, T11, T12, T13, T14, T15, T16 > Class Template Reference

## Public Member Functions

| factory ()
| Default constructor.
template<typename T>
T * | create_from_type ()
| Creates the object. Default constructor.
template<typename T, typename TP1>
T * | create_from_type (const TP1 &p1)
| Creates the object. One parameter constructor.
template<typename T, typename TP1, typename TP2>
T * | create_from_type (const TP1 &p1, const TP2 &p2)
| Creates the object. Two parameter constructor.
template<typename T, typename TP1, typename TP2, typename TP3>
T * | create_from_type (const TP1 &p1, const TP2 &p2, const TP3 &p3)
| Creates the object. Three parameter constructor.
template<typename T, typename TP1, typename TP2, typename TP3, typename TP4>
T * | create_from_type (const TP1 &p1, const TP2 &p2, const TP3 &p3, const TP4 &p4)
| Creates the object. Four parameter constructor.
template<size_t ID>
lookup_t::template type_from_id< ID >::type * | create_from_id ()
| Creates the object from an index. Default constructor.
template<size_t ID, typename TP1>
lookup_t::template type_from_id< ID >::type * | create_from_id (const TP1 &p1)
| Creates the object from an index. One parameter constructor.
template<size_t ID, typename TP1, typename TP2>
lookup_t::template type_from_id< ID >::type * | create_from_id (const TP1 &p1, const TP2 &p2)
| Creates the object from an index. Two parameter constructor.
template<size_t ID, typename TP1, typename TP2, typename TP3>
lookup_t::template type_from_id< ID >::type * | create_from_id (const TP1 &p1, const TP2 &p2, const TP3 &p3)
| Creates the object from an index. Three parameter constructor.
template<size_t ID, typename TP1, typename TP2, typename TP3, typename TP4>
lookup_t::template type_from_id< ID >::type * | create_from_id (const TP1 &p1, const TP2 &p2, const TP3 &p3, const TP4 &p4)
| Creates the object from an index. Three parameter constructor.
template<typename T>
bool | destroy (const T *const p)
| Destroys the object.
size_t | max_size () const
| Returns the maximum number of items in the factory.
size_t | available () const
| Returns the number of free items in the factory.
size_t | size () const
| Returns the number of allocated items in the factory.
bool | empty () const
bool | full () const

## Static Public Attributes

static const size_t | MAX_SIZE = MAX_SIZE_

## Member Function Documentation

## empty()

template<const size_t MAX_SIZE_, typename T1, typename T2 = etl::type_id_pair<etl::null_type, -2>, typename T3 = etl::type_id_pair<etl::null_type, -3>, typename T4 = etl::type_id_pair<etl::null_type, -4>, typename T5 = etl::type_id_pair<etl::null_type, -5>, typename T6 = etl::type_id_pair<etl::null_type, -6>, typename T7 = etl::type_id_pair<etl::null_type, -7>, typename T8 = etl::type_id_pair<etl::null_type, -8>, typename T9 = etl::type_id_pair<etl::null_type, -9>, typename T10 = etl::type_id_pair<etl::null_type, -10>, typename T11 = etl::type_id_pair<etl::null_type, -11>, typename T12 = etl::type_id_pair<etl::null_type, -12>, typename T13 = etl::type_id_pair<etl::null_type, -13>, typename T14 = etl::type_id_pair<etl::null_type, -14>, typename T15 = etl::type_id_pair<etl::null_type, -15>, typename T16 = etl::type_id_pair<etl::null_type, -16>>

bool etl::factory< MAX_SIZE_, T1, T2, T3, T4, T5, T6, T7, T8, T9, T10, T11, T12, T13, T14, T15, T16 >::empty | ( |  | ) | const

inline

Checks to see if there are no allocated items in the factory.

Returns
  true if there are none allocated.

## full()

template<const size_t MAX_SIZE_, typename T1, typename T2 = etl::type_id_pair<etl::null_type, -2>, typename T3 = etl::type_id_pair<etl::null_type, -3>, typename T4 = etl::type_id_pair<etl::null_type, -4>, typename T5 = etl::type_id_pair<etl::null_type, -5>, typename T6 = etl::type_id_pair<etl::null_type, -6>, typename T7 = etl::type_id_pair<etl::null_type, -7>, typename T8 = etl::type_id_pair<etl::null_type, -8>, typename T9 = etl::type_id_pair<etl::null_type, -9>, typename T10 = etl::type_id_pair<etl::null_type, -10>, typename T11 = etl::type_id_pair<etl::null_type, -11>, typename T12 = etl::type_id_pair<etl::null_type, -12>, typename T13 = etl::type_id_pair<etl::null_type, -13>, typename T14 = etl::type_id_pair<etl::null_type, -14>, typename T15 = etl::type_id_pair<etl::null_type, -15>, typename T16 = etl::type_id_pair<etl::null_type, -16>>

bool etl::factory< MAX_SIZE_, T1, T2, T3, T4, T5, T6, T7, T8, T9, T10, T11, T12, T13, T14, T15, T16 >::full | ( |  | ) | const

inline

Checks to see if there are no free items in the factory.

Returns
  true if there are none free.

The documentation for this class was generated from the following file:

- include/etl/deprecated/factory.h